<html>
<head>
<title>OgreTerrainMaterialGeneratorA.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_f1fa7196649e3987904dbdb4948bc856.html">Components</a>      </li>
      <li class="navelem"><a class="el" href="dir_6cd0971983c3e0e5b0cb362e5db7fc9d.html">Terrain</a>      </li>
      <li class="navelem"><a class="el" href="dir_9b506231b651991d884bb23d993d7984.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreTerrainMaterialGeneratorA.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreTerrainMaterialGeneratorA_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __Ogre_TerrainMaterialGeneratorA_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __Ogre_TerrainMaterialGeneratorA_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreTerrainPrerequisites_8h.html">OgreTerrainPrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreTerrainMaterialGenerator_8h.html">OgreTerrainMaterialGenerator.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreGpuProgramParams_8h.html">OgreGpuProgramParams.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038     <span class="keyword">class </span>PSSMShadowCameraSetup;
<a name="l00039"></a>00039 
<a name="l00053"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA.html">00053</a>     <span class="keyword">class </span><a class="code" href="OgreTerrainPrerequisites_8h.html#a2fbe49b54cb4b3c3e2757cd3ac167068">_OgreTerrainExport</a> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA.html" title="A TerrainMaterialGenerator which can cope with normal mapped, specular mapped terrain.">TerrainMaterialGeneratorA</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1TerrainMaterialGenerator.html" title="Class that provides functionality to generate materials for use with a terrain.">TerrainMaterialGenerator</a>
<a name="l00054"></a>00054     {
<a name="l00055"></a>00055     <span class="keyword">public</span>:
<a name="l00056"></a>00056         <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA.html" title="A TerrainMaterialGenerator which can cope with normal mapped, specular mapped terrain.">TerrainMaterialGeneratorA</a>();
<a name="l00057"></a>00057         ~<a class="code" href="classOgre_1_1TerrainMaterialGeneratorA.html" title="A TerrainMaterialGenerator which can cope with normal mapped, specular mapped terrain.">TerrainMaterialGeneratorA</a>();
<a name="l00058"></a>00058 
<a name="l00061"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html">00061</a>         <span class="keyword">class </span><a class="code" href="OgreTerrainPrerequisites_8h.html#a2fbe49b54cb4b3c3e2757cd3ac167068">_OgreTerrainExport</a> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1TerrainMaterialGenerator.html" title="Class that provides functionality to generate materials for use with a terrain.">TerrainMaterialGenerator</a>::<a class="code" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html" title="Inner class which should also be subclassed to provide profile-specific material generation.">Profile</a>
<a name="l00062"></a>00062         {
<a name="l00063"></a>00063         <span class="keyword">public</span>:
<a name="l00064"></a>00064             <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>(<a class="code" href="classOgre_1_1TerrainMaterialGenerator.html" title="Class that provides functionality to generate materials for use with a terrain.">TerrainMaterialGenerator</a>* parent, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; desc);
<a name="l00065"></a>00065             ~<a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>();
<a name="l00066"></a>00066             <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> generate(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain);
<a name="l00067"></a>00067             <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> generateForCompositeMap(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain);
<a name="l00068"></a>00068             <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> getMaxLayers(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain) <span class="keyword">const</span>;
<a name="l00069"></a>00069             <span class="keywordtype">void</span> updateParams(<span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; mat, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain);
<a name="l00070"></a>00070             <span class="keywordtype">void</span> updateParamsForCompositeMap(<span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; mat, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain);
<a name="l00071"></a>00071             <span class="keywordtype">void</span> requestOptions(<a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain);
<a name="l00072"></a>00072             <span class="keywordtype">bool</span> isVertexCompressionSupported() <span class="keyword">const</span>;
<a name="l00073"></a>00073 
<a name="l00076"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#aa7b2eb469c435af1c39275a2df6f5df5">00076</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#aa7b2eb469c435af1c39275a2df6f5df5" title="Whether to support normal mapping per layer in the shader (default true).">isLayerNormalMappingEnabled</a>()<span class="keyword"> const  </span>{ <span class="keywordflow">return</span> mLayerNormalMappingEnabled; }
<a name="l00079"></a>00079             <span class="keywordtype">void</span> setLayerNormalMappingEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00082"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a9a2d4edabc24d3f1e13374eab1fd418a">00082</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a9a2d4edabc24d3f1e13374eab1fd418a" title="Whether to support parallax mapping per layer in the shader (default true).">isLayerParallaxMappingEnabled</a>()<span class="keyword"> const  </span>{ <span class="keywordflow">return</span> mLayerParallaxMappingEnabled; }
<a name="l00085"></a>00085             <span class="keywordtype">void</span> setLayerParallaxMappingEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00088"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a60d69b5cea91acd6bdb43d865fb440b6">00088</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a60d69b5cea91acd6bdb43d865fb440b6" title="Whether to support specular mapping per layer in the shader (default true).">isLayerSpecularMappingEnabled</a>()<span class="keyword"> const  </span>{ <span class="keywordflow">return</span> mLayerSpecularMappingEnabled; }
<a name="l00091"></a>00091             <span class="keywordtype">void</span> setLayerSpecularMappingEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00095"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a66ef7521dd85f69919cebbe2fb324f51">00095</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a66ef7521dd85f69919cebbe2fb324f51" title="Whether to support a global colour map over the terrain in the shader, if it&#39;s present (default true)...">isGlobalColourMapEnabled</a>()<span class="keyword"> const  </span>{ <span class="keywordflow">return</span> mGlobalColourMapEnabled; }
<a name="l00099"></a>00099             <span class="keywordtype">void</span> setGlobalColourMapEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00103"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a833ec32fecc73e02debc7956cee46670">00103</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a833ec32fecc73e02debc7956cee46670" title="Whether to support a light map over the terrain in the shader, if it&#39;s present (default true)...">isLightmapEnabled</a>()<span class="keyword"> const  </span>{ <span class="keywordflow">return</span> mLightmapEnabled; }
<a name="l00107"></a>00107             <span class="keywordtype">void</span> setLightmapEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00111"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#ad3d9c9c043e0ea4d82f6166786dc1956">00111</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#ad3d9c9c043e0ea4d82f6166786dc1956" title="Whether to use the composite map to provide a lower LOD technique in the distance (default true)...">isCompositeMapEnabled</a>()<span class="keyword"> const  </span>{ <span class="keywordflow">return</span> mCompositeMapEnabled; }
<a name="l00115"></a>00115             <span class="keywordtype">void</span> setCompositeMapEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00119"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a4db492f0578c8f1d3edbc32b31d4ba59">00119</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a4db492f0578c8f1d3edbc32b31d4ba59" title="Whether to support dynamic texture shadows received from other objects, on the terrain (default true)...">getReceiveDynamicShadowsEnabled</a>()<span class="keyword"> const  </span>{ <span class="keywordflow">return</span> mReceiveDynamicShadows; }
<a name="l00123"></a>00123             <span class="keywordtype">void</span> setReceiveDynamicShadowsEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00124"></a>00124 
<a name="l00128"></a>00128             <span class="keywordtype">void</span> setReceiveDynamicShadowsPSSM(<a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html" title="Parallel Split Shadow Map (PSSM) shadow camera setup.">PSSMShadowCameraSetup</a>* pssmSettings);
<a name="l00132"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a77f9b821d617a70e2bfcebfd20a170c2">00132</a>             <a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html" title="Parallel Split Shadow Map (PSSM) shadow camera setup.">PSSMShadowCameraSetup</a>* <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a77f9b821d617a70e2bfcebfd20a170c2" title="Whether to use PSSM support dynamic texture shadows, and if so the settings to use (default 0)...">getReceiveDynamicShadowsPSSM</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mPSSM; }
<a name="l00135"></a>00135             <span class="keywordtype">void</span> setReceiveDynamicShadowsDepth(<span class="keywordtype">bool</span> enabled);
<a name="l00138"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a874a874b28414ae10dfec2ae8f6bb08f">00138</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a874a874b28414ae10dfec2ae8f6bb08f" title="Whether to use depth shadows (default false).">getReceiveDynamicShadowsDepth</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mDepthShadows; }
<a name="l00141"></a>00141             <span class="keywordtype">void</span> setReceiveDynamicShadowsLowLod(<span class="keywordtype">bool</span> enabled);
<a name="l00144"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a5794ec030c7dcbcf2ad36c473b19875b">00144</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a5794ec030c7dcbcf2ad36c473b19875b" title="Whether to use shadows on low LOD material rendering (when using composite map) (default false)...">getReceiveDynamicShadowsLowLod</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mLowLodShadows; }
<a name="l00145"></a>00145 
<a name="l00147"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a35b8394758ead4cb05487f0bbdc3758c">00147</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a35b8394758ead4cb05487f0bbdc3758c" title="Internal.">_isSM3Available</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSM3Available; }
<a name="l00148"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a0219afa39a19812e90ff2919fd12fe68">00148</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a0219afa39a19812e90ff2919fd12fe68">_isSM4Available</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSM4Available; }
<a name="l00149"></a>00149         
<a name="l00150"></a>00150         <span class="keyword">protected</span>:
<a name="l00151"></a>00151 
<a name="l00152"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">00152</a>             <span class="keyword">enum</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a>
<a name="l00153"></a>00153             {
<a name="l00154"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6ae9bf14967819538907449efd1bcbcb0c">00154</a>                 <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6ae9bf14967819538907449efd1bcbcb0c">HIGH_LOD</a>, 
<a name="l00155"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6a1667917f1585a011c73d4240393d7425">00155</a>                 <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6a1667917f1585a011c73d4240393d7425">LOW_LOD</a>, 
<a name="l00156"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6add7e315fae37ebe707116941e8c7a482">00156</a>                 RENDER_COMPOSITE_MAP
<a name="l00157"></a>00157             };
<a name="l00158"></a>00158             <span class="keywordtype">void</span> addTechnique(<span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; mat, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, TechniqueType tt);
<a name="l00159"></a>00159 
<a name="l00161"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html">00161</a>             <span class="keyword">class </span><a class="code" href="OgreTerrainPrerequisites_8h.html#a2fbe49b54cb4b3c3e2757cd3ac167068">_OgreTerrainExport</a> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html" title="Interface definition for helper class to generate shaders.">ShaderHelper</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">TerrainAlloc</a>
<a name="l00162"></a>00162             {
<a name="l00163"></a>00163             <span class="keyword">public</span>:
<a name="l00164"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#ac76120b3aa747d1f2adbe9e2fc374be1">00164</a>                 <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#ac76120b3aa747d1f2adbe9e2fc374be1">ShaderHelper</a>() {}
<a name="l00165"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a28ad3f6af71a8b65f4af872f15e5a0a1">00165</a>                 <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a28ad3f6af71a8b65f4af872f15e5a0a1">~ShaderHelper</a>() {}
<a name="l00166"></a>00166                 <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to HighLevelGpuProgramPtr.">HighLevelGpuProgramPtr</a> generateVertexProgram(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt);
<a name="l00167"></a>00167                 <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to HighLevelGpuProgramPtr.">HighLevelGpuProgramPtr</a> generateFragmentProgram(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt);
<a name="l00168"></a>00168                 <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateParams(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; mat, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <span class="keywordtype">bool</span> compositeMap);
<a name="l00169"></a>00169             <span class="keyword">protected</span>:
<a name="l00170"></a>00170                 <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> getVertexProgramName(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt);
<a name="l00171"></a>00171                 <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> getFragmentProgramName(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt);
<a name="l00172"></a>00172                 <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to HighLevelGpuProgramPtr.">HighLevelGpuProgramPtr</a> createVertexProgram(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt) = 0;
<a name="l00173"></a>00173                 <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to HighLevelGpuProgramPtr.">HighLevelGpuProgramPtr</a> createFragmentProgram(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt) = 0;
<a name="l00174"></a>00174                 <span class="keyword">virtual</span> <span class="keywordtype">void</span> generateVertexProgramSource(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream);
<a name="l00175"></a>00175                 <span class="keyword">virtual</span> <span class="keywordtype">void</span> generateFragmentProgramSource(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream);
<a name="l00176"></a>00176                 <span class="keyword">virtual</span> <span class="keywordtype">void</span> generateVpHeader(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream) = 0;
<a name="l00177"></a>00177                 <span class="keyword">virtual</span> <span class="keywordtype">void</span> generateFpHeader(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream) = 0;
<a name="l00178"></a>00178                 <span class="keyword">virtual</span> <span class="keywordtype">void</span> generateVpLayer(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> layer, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream) = 0;
<a name="l00179"></a>00179                 <span class="keyword">virtual</span> <span class="keywordtype">void</span> generateFpLayer(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> layer, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream) = 0;
<a name="l00180"></a>00180                 <span class="keyword">virtual</span> <span class="keywordtype">void</span> generateVpFooter(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream) = 0;
<a name="l00181"></a>00181                 <span class="keyword">virtual</span> <span class="keywordtype">void</span> generateFpFooter(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream) = 0;
<a name="l00182"></a>00182                 <span class="keyword">virtual</span> <span class="keywordtype">void</span> defaultVpParams(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <span class="keyword">const</span> <a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to HighLevelGpuProgramPtr.">HighLevelGpuProgramPtr</a>&amp; prog);
<a name="l00183"></a>00183                 <span class="keyword">virtual</span> <span class="keywordtype">void</span> defaultFpParams(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <span class="keyword">const</span> <a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to HighLevelGpuProgramPtr.">HighLevelGpuProgramPtr</a>&amp; prog);
<a name="l00184"></a>00184                 <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateVpParams(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a>&amp; params);
<a name="l00185"></a>00185                 <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateFpParams(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a>&amp; params);
<a name="l00186"></a>00186                 <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> getChannel(<a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> idx);
<a name="l00187"></a>00187 
<a name="l00188"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a517f480f42d873878c2ffe3ef464afb7">00188</a>                 <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#a517f480f42d873878c2ffe3ef464afb7">mShadowSamplerStartHi</a>;
<a name="l00189"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#adf1108ee4e3b76d105732210ccf4ff51">00189</a>                 <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html#adf1108ee4e3b76d105732210ccf4ff51">mShadowSamplerStartLo</a>;
<a name="l00190"></a>00190 
<a name="l00191"></a>00191             };
<a name="l00192"></a>00192 
<a name="l00194"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperCg.html">00194</a>             <span class="keyword">class </span><a class="code" href="OgreTerrainPrerequisites_8h.html#a2fbe49b54cb4b3c3e2757cd3ac167068">_OgreTerrainExport</a> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperCg.html" title="Utility class to help with generating shaders for Cg / HLSL.">ShaderHelperCg</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html" title="Interface definition for helper class to generate shaders.">ShaderHelper</a>
<a name="l00195"></a>00195             {
<a name="l00196"></a>00196             <span class="keyword">protected</span>:
<a name="l00197"></a>00197                 <a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to HighLevelGpuProgramPtr.">HighLevelGpuProgramPtr</a> createVertexProgram(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt);
<a name="l00198"></a>00198                 <a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to HighLevelGpuProgramPtr.">HighLevelGpuProgramPtr</a> createFragmentProgram(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt);
<a name="l00199"></a>00199                 <span class="keywordtype">void</span> generateVpHeader(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream);
<a name="l00200"></a>00200                 <span class="keywordtype">void</span> generateFpHeader(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream);
<a name="l00201"></a>00201                 <span class="keywordtype">void</span> generateVpLayer(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> layer, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream);
<a name="l00202"></a>00202                 <span class="keywordtype">void</span> generateFpLayer(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> layer, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream);
<a name="l00203"></a>00203                 <span class="keywordtype">void</span> generateVpFooter(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream);
<a name="l00204"></a>00204                 <span class="keywordtype">void</span> generateFpFooter(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream);
<a name="l00205"></a>00205                 <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> generateVpDynamicShadowsParams(<a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> texCoordStart, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream);
<a name="l00206"></a>00206                 <span class="keywordtype">void</span> generateVpDynamicShadows(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream);
<a name="l00207"></a>00207                 <span class="keywordtype">void</span> generateFpDynamicShadowsHelpers(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream);
<a name="l00208"></a>00208                 <span class="keywordtype">void</span> generateFpDynamicShadowsParams(<a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a>* texCoord, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a>* sampler, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream);
<a name="l00209"></a>00209                 <span class="keywordtype">void</span> generateFpDynamicShadows(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream);
<a name="l00210"></a>00210             };
<a name="l00211"></a>00211 
<a name="l00212"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperHLSL.html">00212</a>             <span class="keyword">class </span><a class="code" href="OgreTerrainPrerequisites_8h.html#a2fbe49b54cb4b3c3e2757cd3ac167068">_OgreTerrainExport</a> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperHLSL.html">ShaderHelperHLSL</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperCg.html" title="Utility class to help with generating shaders for Cg / HLSL.">ShaderHelperCg</a>
<a name="l00213"></a>00213             {
<a name="l00214"></a>00214             <span class="keyword">protected</span>:
<a name="l00215"></a>00215                 <a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to HighLevelGpuProgramPtr.">HighLevelGpuProgramPtr</a> createVertexProgram(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt);
<a name="l00216"></a>00216                 <a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to HighLevelGpuProgramPtr.">HighLevelGpuProgramPtr</a> createFragmentProgram(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt);
<a name="l00217"></a>00217             };
<a name="l00218"></a>00218 
<a name="l00220"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSL.html">00220</a>             <span class="keyword">class </span><a class="code" href="OgreTerrainPrerequisites_8h.html#a2fbe49b54cb4b3c3e2757cd3ac167068">_OgreTerrainExport</a> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSL.html" title="Utility class to help with generating shaders for GLSL.">ShaderHelperGLSL</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html" title="Interface definition for helper class to generate shaders.">ShaderHelper</a>
<a name="l00221"></a>00221             {
<a name="l00222"></a>00222             <span class="keyword">protected</span>:
<a name="l00223"></a>00223                 <a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to HighLevelGpuProgramPtr.">HighLevelGpuProgramPtr</a> createVertexProgram(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt);
<a name="l00224"></a>00224                 <a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to HighLevelGpuProgramPtr.">HighLevelGpuProgramPtr</a> createFragmentProgram(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt);
<a name="l00225"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSL.html#a3d51b17533918821cb4e8956f8512001">00225</a>                 <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSL.html#a3d51b17533918821cb4e8956f8512001">generateVpHeader</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream) {}
<a name="l00226"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSL.html#a68f3f6c366858cf8b582a9c76f7b3df9">00226</a>                 <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSL.html#a68f3f6c366858cf8b582a9c76f7b3df9">generateFpHeader</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream) {}
<a name="l00227"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSL.html#a87416982cb2fbd8c558ef9bf538085d7">00227</a>                 <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSL.html#a87416982cb2fbd8c558ef9bf538085d7">generateVpLayer</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> layer, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream) {}
<a name="l00228"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSL.html#abfecfbe202c996226a28ab1c576b0dd0">00228</a>                 <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSL.html#abfecfbe202c996226a28ab1c576b0dd0">generateFpLayer</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> layer, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream) {}
<a name="l00229"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSL.html#a910ef39e1781038f2f54369b4d80d6b4">00229</a>                 <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSL.html#a910ef39e1781038f2f54369b4d80d6b4">generateVpFooter</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream) {}
<a name="l00230"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSL.html#a1b01e08ebcd6fe459aa620dd097b2c41">00230</a>                 <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSL.html#a1b01e08ebcd6fe459aa620dd097b2c41">generateFpFooter</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream) {}
<a name="l00231"></a>00231             };
<a name="l00232"></a>00232 
<a name="l00234"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSLES.html">00234</a>             <span class="keyword">class </span><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSLES.html" title="Utility class to help with generating shaders for GLSL ES.">ShaderHelperGLSLES</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html" title="Interface definition for helper class to generate shaders.">ShaderHelper</a>
<a name="l00235"></a>00235             {
<a name="l00236"></a>00236             <span class="keyword">protected</span>:
<a name="l00237"></a>00237                 <a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to HighLevelGpuProgramPtr.">HighLevelGpuProgramPtr</a> createVertexProgram(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt);
<a name="l00238"></a>00238                 <a class="code" href="classOgre_1_1HighLevelGpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to HighLevelGpuProgramPtr.">HighLevelGpuProgramPtr</a> createFragmentProgram(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt);
<a name="l00239"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSLES.html#a18e1833c0535e51eb79999193b779bed">00239</a>                 <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSLES.html#a18e1833c0535e51eb79999193b779bed">generateVpHeader</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream) {}
<a name="l00240"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSLES.html#abb0bbc0237a9965d7e6af63ad71728f6">00240</a>                 <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSLES.html#abb0bbc0237a9965d7e6af63ad71728f6">generateFpHeader</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream) {}
<a name="l00241"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSLES.html#addf9378c351fa14c7f1fdc571cdc5ad9">00241</a>                 <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSLES.html#addf9378c351fa14c7f1fdc571cdc5ad9">generateVpLayer</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> layer, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream) {}
<a name="l00242"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSLES.html#a23224df675ca0684963d6a03bba9787b">00242</a>                 <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSLES.html#a23224df675ca0684963d6a03bba9787b">generateFpLayer</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> layer, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream) {}
<a name="l00243"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSLES.html#a86bc10c0a63dc6ea355afd7f81e70537">00243</a>                 <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSLES.html#a86bc10c0a63dc6ea355afd7f81e70537">generateVpFooter</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream) {}
<a name="l00244"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSLES.html#a152be5e7994924fdeb1072885f95d55a">00244</a>                 <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelperGLSLES.html#a152be5e7994924fdeb1072885f95d55a">generateFpFooter</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html" title="Shader model 2 profile target.">SM2Profile</a>* prof, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain, <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StringUtil::StrStreamType</a>&amp; outStream) {}
<a name="l00245"></a>00245             };
<a name="l00246"></a>00246 
<a name="l00247"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#acae9c5703a00d1029be4a514ca1a80c3">00247</a>             <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile_1_1ShaderHelper.html" title="Interface definition for helper class to generate shaders.">ShaderHelper</a>* <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#acae9c5703a00d1029be4a514ca1a80c3">mShaderGen</a>;
<a name="l00248"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#ab5ab431ad1da8ff2bd12b7cc1ac3ed84">00248</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#ab5ab431ad1da8ff2bd12b7cc1ac3ed84">mLayerNormalMappingEnabled</a>;
<a name="l00249"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a60147fa5e6ec233d79320ea162990dba">00249</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a60147fa5e6ec233d79320ea162990dba">mLayerParallaxMappingEnabled</a>;
<a name="l00250"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#ac22548696e67f07f3befc570cb82d6f4">00250</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#ac22548696e67f07f3befc570cb82d6f4">mLayerSpecularMappingEnabled</a>;
<a name="l00251"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a818ddd1b2d4ef24144341b85f2b4a598">00251</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a818ddd1b2d4ef24144341b85f2b4a598">mGlobalColourMapEnabled</a>;
<a name="l00252"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#aa10b6fc714fdc38555c61c8f23b82e6c">00252</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#aa10b6fc714fdc38555c61c8f23b82e6c">mLightmapEnabled</a>;
<a name="l00253"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a429321b7bd9711a38b0ba66a649e3d27">00253</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a429321b7bd9711a38b0ba66a649e3d27">mCompositeMapEnabled</a>;
<a name="l00254"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#ad3155265d403873d0d68895603d28775">00254</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#ad3155265d403873d0d68895603d28775">mReceiveDynamicShadows</a>;
<a name="l00255"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a035f732a574ad4c1b6577543409f0539">00255</a>             <a class="code" href="classOgre_1_1PSSMShadowCameraSetup.html" title="Parallel Split Shadow Map (PSSM) shadow camera setup.">PSSMShadowCameraSetup</a>* <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a035f732a574ad4c1b6577543409f0539">mPSSM</a>;
<a name="l00256"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#ab57987d5aa3bbb3485c85677d71d94b0">00256</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#ab57987d5aa3bbb3485c85677d71d94b0">mDepthShadows</a>;
<a name="l00257"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a6c389f7f02f39525a242c3802f6f3845">00257</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a6c389f7f02f39525a242c3802f6f3845">mLowLodShadows</a>;
<a name="l00258"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#aa18a0db225756b5c805f2ae151bab054">00258</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#aa18a0db225756b5c805f2ae151bab054">mSM3Available</a>;
<a name="l00259"></a><a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#aa592323fb775361854cbe921365aa561">00259</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#aa592323fb775361854cbe921365aa561">mSM4Available</a>;
<a name="l00260"></a>00260 
<a name="l00261"></a>00261             <span class="keywordtype">bool</span> isShadowingEnabled(<a class="code" href="classOgre_1_1TerrainMaterialGeneratorA_1_1SM2Profile.html#a626162178bf4831bcdc1a5138e5772c6">TechniqueType</a> tt, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>* terrain) <span class="keyword">const</span>;
<a name="l00262"></a>00262 
<a name="l00263"></a>00263         };
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 
<a name="l00266"></a>00266 
<a name="l00267"></a>00267 
<a name="l00268"></a>00268     };
<a name="l00269"></a>00269 
<a name="l00270"></a>00270 
<a name="l00271"></a>00271 
<a name="l00276"></a>00276 }
<a name="l00277"></a>00277 
<a name="l00278"></a>00278 <span class="preprocessor">#endif</span>
<a name="l00279"></a>00279 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
